// Education.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

const unsigned int RND_PERIOD=16;
enum RANDOMMODE{
	RD_TIME=0,
	RD_LONG,
	RD_XORS
};
//const RANDOMMODE rdm=RD_TIME;
//const RANDOMMODE rdm=RD_LONG;
const RANDOMMODE rdm=RD_XORS;

static long int xors=123456789;
long int xorsRand(){ 
    static long int y=362436069,z=521288629,w=88675123; 
    long int t; 
    t=(xors^(xors<<11));xors=y;y=z;z=w; return( w=(w^(w>>19))^(t^(t>>8)) ); 
} 
void xorsSRand(){
	int i;
	srand((unsigned)time(NULL));
	for(i=0;i<rand();i++) xorsRand(); 
}

long int XORSRandom(long int nmin,long int nmax)
{
	double a=(double)(xorsRand()%LONG_MAX)/(double)LONG_MAX;
	if(nmax<nmin){long int tmp=nmax;nmax=nmin;nmin=tmp;}
	long int c=(long int)(a*(((double)nmax-(double)nmin)+1.0));
	return c;
}

double DoubleXORSRandom()
{
	double a=(double)(xorsRand()%LONG_MAX)/((double)LONG_MAX);
	double b=(double)(xorsRand()%LONG_MAX)/((double)LONG_MAX*(double)LONG_MAX);
	return a+b;
}

int TimeRandom(int nmin,int nmax)
{
	static int cnt=0;
	unsigned int t=timeGetTime()%RND_PERIOD,i;
	for(i=0;i<t;i++)rand();
	if(nmax<nmin){int tmp=nmax;nmax=nmin;nmin=tmp;}
	return (int)(((double)rand()*((double)nmax-(double)nmin+1.0))/((double)RAND_MAX+1.0));
}
long int LongRandom(long int nmin,long int nmax)
{
	double a=(double)rand()/((double)RAND_MAX+1.0);
	double b=(double)rand()/((double)RAND_MAX*(double)RAND_MAX+1.0);
	if(nmax<nmin){long long int tmp=nmax;nmax=nmin;nmin=tmp;}
	long long int c=(long long int)((a+b)*(((double)nmax-(double)nmin)+1.0));
	return c;
}
int Random(long int nmin,long int nmax)
{
	switch(rdm)
	{
	case RD_TIME:
		return TimeRandom((int)nmin,(int)nmax);
	case RD_LONG:
		return (int)LongRandom(nmin,nmax);
	case RD_XORS:
		return (int)XORSRandom(nmin,nmax);
	}
	return 0;
}

int g_n=1;
int g_t=0;
int g_data[2][6]={0};
const int RANGE=20;
const float RATE=1.5f;

int ai()
{
	int ret=0,i,j,k,n=0x7fffffff;
	for(i=0;i<6;i++)
	{
		if(g_data[g_t][i]<n)n=g_data[g_t][i];
	}
	for(j=i=0;i<6;i++)
	{
		if(g_data[g_t][i]==n)j++;
	}
	k=Random(0,j-1);
	for(j=i=0;i<6;i++)
	{
		if(g_data[g_t][i]==n)
		{
			if(k==j)
			{
				ret=i;
				break;
			}
			j++;
		}
	}
	return ret;
}

int doing()
{
	int i,ret=Random(0,5);
	if(g_n%RANGE==0)
	{
		if(g_t==0)
		{
			g_t=1;
			for(i=0;i<6;i++)
			{
				g_data[1][i]=(int)((float)g_data[0][i]/RATE);
				g_data[0][i]=0;
			}
		}
		else
		{
			g_t=0;
			for(i=0;i<6;i++)
			{
				g_data[0][i]=(int)((float)g_data[1][i]/RATE);
				g_data[1][i]=0;
			}
		}
	}
	g_data[g_t][ret]=g_data[g_t][ret]+1;
	return ret;
}

void dispai(int n,int right,int a,int r)
{
	printf("%dځF\%dF%dFI%.02f\n",n,a+1,r+1,((float)right*100.0f/(float)n));
}

int _tmain(int argc, _TCHAR* argv[])
{
	xorsSRand();

START:
	g_n=1;
	int right=0,a,r,ntime;
	char c;
	fflush(stdin);
	printf("ntime?_");
	scanf("%d",&ntime);
	while(true)
	{
		fflush(stdin);
		a=ai();
		r=doing();
		if(a==r) right++;
		dispai(g_n,right,a,r);
			if(!(ntime<1))
		{
			if(ntime<=g_n) break;
		}
		else
		{
			printf("end?(y/n)_");
			scanf("%c",&c);
			if(c=='Y'||c=='y') break;
		}
		g_n++;
	}
	printf("retry?(y/n)_");
	scanf("%c",&c);
	if(c=='Y'||c=='y') goto START;
		
	return 0;
}
