// Roulette.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

const unsigned int RND_PERIOD=16;
enum RANDOMMODE{
	RD_TIME=0,
	RD_LONG,
	RD_XORS
};
//const RANDOMMODE rdm=RD_TIME;
//const RANDOMMODE rdm=RD_LONG;
const RANDOMMODE rdm=RD_XORS;

static long int xors=123456789;
long int xorsRand(){ 
    static long int y=362436069,z=521288629,w=88675123; 
    long int t; 
    t=(xors^(xors<<11));xors=y;y=z;z=w; return( w=(w^(w>>19))^(t^(t>>8)) ); 
} 
void xorsSRand(){
	int i;
	srand((unsigned)time(NULL));
	for(i=0;i<rand();i++) xorsRand(); 
}

long int XORSRandom(long int nmin,long int nmax)
{
	double a=(double)(xorsRand()%LONG_MAX)/(double)LONG_MAX;
	if(nmax<nmin){long int tmp=nmax;nmax=nmin;nmin=tmp;}
	long int c=(long int)(a*(((double)nmax-(double)nmin)+1.0));
	return c;
}

double DoubleXORSRandom()
{
	double a=(double)(xorsRand()%LONG_MAX)/((double)LONG_MAX);
	double b=(double)(xorsRand()%LONG_MAX)/((double)LONG_MAX*(double)LONG_MAX);
	return a+b;
}

int TimeRandom(int nmin,int nmax)
{
	static int cnt=0;
	unsigned int t=timeGetTime()%RND_PERIOD,i;
	for(i=0;i<t;i++)rand();
	if(nmax<nmin){int tmp=nmax;nmax=nmin;nmin=tmp;}
	return (int)(((double)rand()*((double)nmax-(double)nmin+1.0))/((double)RAND_MAX+1.0));
}
long int LongRandom(long int nmin,long int nmax)
{
	double a=(double)rand()/((double)RAND_MAX+1.0);
	double b=(double)rand()/((double)RAND_MAX*(double)RAND_MAX+1.0);
	if(nmax<nmin){long long int tmp=nmax;nmax=nmin;nmin=tmp;}
	long long int c=(long long int)((a+b)*(((double)nmax-(double)nmin)+1.0));
	return c;
}
int Random(long int nmin,long int nmax)
{
	switch(rdm)
	{
	case RD_TIME:
		return TimeRandom((int)nmin,(int)nmax);
	case RD_LONG:
		return (int)LongRandom(nmin,nmax);
	case RD_XORS:
		return (int)XORSRandom(nmin,nmax);
	}
	return 0;
}

int g_n=1;
int g_t=0;
int g_data[2][2][38]={0};
const int RANGE[2]={60,80};
const float RATE[2]={2.5f,3.0f};

void ai(int tryn,int *a)
{
	int ret[4]={0},i,j,k,l,m,n=0x7fffffff,o;
	l=0;
	while(l<4)
	{
		o=n;
		n=0x7fffffff;
		if(o==0x7fffffff)
		{
			for(i=0;i<38;i++)
			{
				if(g_data[tryn][g_t][i]<n)n=g_data[tryn][g_t][i];
			}
			for(j=i=0;i<38;i++)
			{
				if(g_data[tryn][g_t][i]==n)j++;
			}
			for(m=0;m<j;m++)
			{
				if(3<l) goto OPOUT;
				k=Random(0,j-1);
				for(j=i=0;i<38;i++)
				{
					if(g_data[tryn][g_t][i]==n)
					{
						if(k==j)
						{
							ret[l]=i;
							l++;
							break;
						}
						j++;
					}
				}
			}
		}
		else
		{
			for(i=0;i<38;i++)
			{
				if(g_data[tryn][g_t][i]<n&&o<g_data[tryn][g_t][i])n=g_data[tryn][g_t][i];
			}
			for(j=i=0;i<38;i++)
			{
				if(g_data[tryn][g_t][i]==n)j++;
			}
			for(m=0;m<j;m++)
			{
				if(3<l) goto OPOUT;
				k=Random(0,j-1);
				for(j=i=0;i<38;i++)
				{
					if(g_data[tryn][g_t][i]==n)
					{
						if(k==j)
						{
							ret[l]=i;
							l++;
							break;
						}
						j++;
					}
				}
			}
		}
	}

OPOUT:
	for(i=0;i<4;i++)a[i]=ret[i];
}

int doinginput(int tryn,int n)
{
	int i,ret=0;
	int s;
	if(tryn==0)
	{
START:
		fflush(stdin);
		printf("spot=");
		scanf("%d",&s);
		if(s<0||37<s)goto START;
		ret=s;
	}
	else ret=n;
	if(g_n%RANGE[tryn]==0)
	{
		if(g_t==0)
		{
			g_t=1;
			for(i=0;i<38;i++)
			{
				g_data[tryn][1][i]=(int)((float)g_data[tryn][0][i]/RATE[tryn]);
				g_data[tryn][0][i]=0;
			}
		}
		else
		{
			g_t=0;
			for(i=0;i<38;i++)
			{
				g_data[tryn][0][i]=(int)((float)g_data[tryn][1][i]/RATE[tryn]);
				g_data[tryn][1][i]=0;
			}
		}
	}
	g_data[tryn][g_t][ret]=g_data[tryn][g_t][ret]+1;
	fflush(stdin);
	return ret;
}

int doing(int tryn,int n)
{
	int i,ret;
	if(tryn==0)ret=Random(0,37);
	else ret=n;
	if(g_n%RANGE[tryn]==0)
	{
		if(g_t==0)
		{
			g_t=1;
			for(i=0;i<38;i++)
			{
				g_data[tryn][1][i]=(int)((float)g_data[tryn][0][i]/RATE[tryn]);
				g_data[tryn][0][i]=0;
			}
		}
		else
		{
			g_t=0;
			for(i=0;i<38;i++)
			{
				g_data[tryn][0][i]=(int)((float)g_data[tryn][1][i]/RATE[tryn]);
				g_data[tryn][1][i]=0;
			}
		}
	}
	g_data[tryn][g_t][ret]=g_data[tryn][g_t][ret]+1;
	return ret;
}


void charset(char *s,int n)
{
	if(n==37)
	{
		*(s+0)='0';
		*(s+1)='0';
	}
	else if(n/10)
	{
		*(s+0)=(n/10)+'0';
		*(s+1)=(n%10)+'0';
	}
	else
	{
		*(s+0)=' ';
		*(s+1)=(n%10)+'0';
	}
	*(s+2)='\0';
}

void dispai(int n,int right,int* a,int r,int tryn)
{
	char aa[4][3],rr[3];
	int i;
	for(i=0;i<4;i++) charset(aa[i],a[i]);
	charset(rr,r);
	printf("(%d,%.04f)F%dځF\%s-%s-%s-%sF%sFI%.02fFs%.02f\n",RANGE[tryn],RATE[tryn],n,aa[0],aa[1],aa[2],aa[3],rr,((float)right*100.0f/(float)n),((float)right*9.0f/(float)n));
}

int _tmain(int argc, _TCHAR* argv[])
{
	xorsSRand();

START:
	g_n=1;
	bool bb=false;
	int right[2]={0,0},a[4],b[4],r,ntime;
	char c;
	fflush(stdin);
	printf("ntime?_");
	scanf("%d",&ntime);
	if(ntime<1)
	{
		fflush(stdin);
		printf("input?(y/n)_");
		scanf("%c",&c);
		if(c=='Y'||c=='y') bb=true;
	}

	while(true)
	{
		fflush(stdin);
		ai(0,&(a[0]));
		if(bb)
		{
			r=doinginput(0,0);
		}
		else
		{
			r=doing(0,0);
		}
		ai(1,&(b[0]));
		if(bb)
		{
			r=doinginput(1,r);
		}
		else
		{
			r=doing(1,r);
		}


		if(a[0]==r) right[0]++;
		if(a[1]==r) right[0]++;
		if(a[2]==r) right[0]++;
		if(a[3]==r) right[0]++;
		if(b[0]==r) right[1]++;
		if(b[1]==r) right[1]++;
		if(b[2]==r) right[1]++;
		if(b[3]==r) right[1]++;
		dispai(g_n,right[0],&(a[0]),r,0);
		dispai(g_n,right[1],&(b[0]),r,1);
		if(!(ntime<1))
		{
			if(ntime<=g_n) break;
		}
		else
		{
			printf("end?(y/n)_");
			scanf("%c",&c);
			if(c=='Y'||c=='y') break;
		}
		g_n++;
	}
	printf("retry?(y/n)_");
	scanf("%c",&c);
	if(c=='Y'||c=='y') goto START;
		
	return 0;
}